<!DOCTYPE html>
<html lang="fr">
<head>
  <title>Présentation projet : groupe 5</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet">
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js"></script>
  <style>
    figure {
      border: 1px #cccccc solid;
      padding: 4px;
      margin: auto;
    }
    
    figcaption {
      background: rgba(0,0,0,0.7);
      color: white;
      font-style: italic;
      padding: 2px;
      text-align: center;
    }
    </style>
</head>
<body>

<div class="container-fluid p-5 bg-primary text-white text-center">
  <h1>SDL2</h1>
  <p>Groupe 05 : Lucas LARZILLIERE, Tristan VILLETTE, Florian GAVA</p>
  <a href='ProjetS2.html' class="row-sm-4 ">
    <button type="button" class="btn btn-secondary">Retour</button>
  </a>
</div>
<div class="container mt-5">
    <div class="row">
        <h3>La partie graphique avec la SDL2 s'inplémente séparèmment du programme du jeu</h3><br>
        </p>
        <h5>Lorsque le programme est en jeu :<br></h5>
         <p>On récupère la matrice du jeu et les scores à chaque itération.<br>
          Ensuite, on transforme la matrice en deux :</p>
          <code>SDL_matricePlayer=convert_MatricePlayer(monde_dep, taille);                 // Actualisation des joueurs<br>
              SDL_matriceStatic=convert_MatriceStatic(monde_dep,  taille);                // Actualisations des objets statiques</code>
            <p></p>
         <p><code>SDL_matricePlayer</code> est la matrice de la position et du type de joueur,<br>
         <code>SDL_matriceStatic</code> est la matrice de la position des obstacles (arbres) et des bonus (lingots d'or).</p>
         <p>Puis on dessine à la suite dans cet ordre :</p>
         <figure>
          <img src="img/SDL2_BG.png" width="500" height="500">
          <img src="img/SDL2_Static.png" width="500" height="500">
          <img src="img/SDL2_Player.png" width="500" height="500">
          <img src="img/SDL2_score.png" width="500" height="500">
          <img src="img/SDL2_score2.png" width="500" height="500">
          <img src="img/SDL2_boutonmenu.png" width="500" height="500">
         </figure>
         <p>Il y a possibilité de mettre le jeu en pause.<br>
          A ce momment, le menu s'affiche, on arrête d'actualiser ce qu'il y a derrière sauf le bouton retour menu.<br></p>
            <video width="1000" height="600" controls class="row-sm-4">
              <source src="video/Pause.mp4"  type="video/mp4">
            </video>
            <p></p>
            <h5>Lorsque le programme est en menu :<br></h5>
            <p>On dessine dans l'ordre : l'herbe en fond, les animaux qui bougent, les boutons avec l'animations, les nuages puis le titre et sous-titre</p>
            <video width="1000" height="600" controls class="row-sm-4">
              <source src="video/menu.mp4"  type="video/mp4">
            </video>
            <h5>Lorsque le programme est en crédits<br><h5></h5>
              <p>On dessine le fond en bleu clair, on affiche les écritures et on réutilise le même bouton retour menu qu'en jeu</p>
            <video width="1000" height="600" controls class="row-sm-4">
              <source src="video/credits.mp4"  type="video/mp4">
            </video>
            <h5><br>Gestion de l'animation des boutons<br></h5>
              Pour chaque état, il existe un évènement qui détecte un mouvement de souris et qui actualise ainsi la position de la souris</p>
              <figure>
                <img src="img/Eventmouv.png" width="1000" height="500">
              </figure>
              <p> Chaque fonction qui dessine un bouton renvoie le rectangle de sa position dans la fenêtre, qu'on va stocké dans un tabelau de rectangle</p>
              <code>        SDL_Rect *  tabBoutonRect = init_tabSDL_Rect(5),    // Tableau des rectangles de chaque bouton<br>
                //[0]:Etat crédits & jeu : 'retour menu'<br>
                //[1]:Etat menu : 'jouer'<br>
                //[2]:Etat menu : 'crédits'<br>
                //[0]:Etat menu : 'quitter'<br></code>
             <p> Il ne nous reste plus qu'a vérifier si la souris se trouve dans un de ces rectangles, puis à indiquer à la fonction qui dessine le bouton
              sur lequel est la souris, de changer le dessin.<br>
              On utilise pour ça un tableau de booléen qu'on passe à VRAI quand la souris est sur le rectangle :<br>
             <code> SDL_bool *   tabSourisSurBouton=init_tabSDL_bool(5); // Tableau de booléen pour savoir si la souris se trouve sur un bouton <br>          
              //[0]:Etat crédits & jeu : 'retour menu' <br>
              //[1]:Etat menu : 'jouer' <br>
              //[2]:Etat menu : 'crédits' <br>
              //[3]:Etat menu : 'quitter'</code></p>
              <h5><br>Gestion de l'animation du titre menu<br></h5>
              <p>On définit un coef en amont de la fonction de dessin du titre,<br>
              ce coefficient représente le pourcentage d'occupation du titre sur la page.
              On a juste à modifié ce coef pour agrandir ou réduire la taille du titre<br></p>
            <code>if ((coef>0.85)&(statut==0))  statut=1;             // Actualise pour l'animation du titre<br>
              if ((coef<0.8)&(statut==1))  statut=0; <br>
                if (statut==0) coef+=0.01;<br>
                if (statut==1) coef-=0.01;<br>
              </code>
            <h5><br>Gestion de l'animation des animaux sur le menu<br></h5>
            <p>On utilise un <code>rand()</code> qui définit pour chaque case du menus si on place un animal <br>
              si un animal est placé, on sauvegarde la place dans une matrice pour éviter d'un placer un autre dessus
              Puis on passe à l'autre animal<br></p>
              <figure>
                <img src="img/codeAnimal.png" width="1000" height="500">
              </figure>
              <p><br>On a placé un <code>srand()</code> en début de fonction pour changer le <code>rand()</code>chaque seconde </p>
    </div>
</div>


</body>
</html>
